# Class Dialog

java.lang.Object
com.codename1.ui.Component
com.codename1.ui.Container
com.codename1.ui.Form
com.codename1.ui.Dialog

All Implemented Interfaces:
  `Animation, Editable, StyleListener, Iterable<Component>`

Direct Known Subclasses:
  `Progress`

public class Dialog extends Form

A dialog is a form that occupies a part of the screen and appears as a modal entity to the developer. Dialogs allow us to prompt users for information and rely on the information being available on the next line after the show method.

Modality indicates that a dialog will block the calling thread even if the calling thread is the EDT. Notice that a dialog will not release the block until dispose is called even if show() from another form is called! Events are still performed thanks to the `com.codename1.ui.Display#invokeAndBlock(java.lang.Runnable)` capability of the `Display` class.

To determine the size of the dialog use the show method that accepts 4 integer values, notice that these values accept margin from the four sides rather than x, y, width and height values!

It's important to style a `Dialog` using `Dialog#getDialogStyle()` or `Dialog#setDialogUIID(java.lang.String)` methods rather than styling the dialog object directly.

The `Dialog` class also includes support for popup dialog which is a dialog type that is positioned next to a component or screen area and points an arrow at that location.

Typical dialog usage looks like this:

    final Button show = new Button("Show Dialog");
    final Button showPopup = new Button("Show Popup");
    cnt.add(show).add(showPopup);
    show.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
            Dialog.show("Dialog Title", "This is the dialog body, it can contain anything...", "OK", "Cancel");
        }
    });
    showPopup.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent evt) {
            Dialog d = new Dialog("Popup Title");
            TextArea popupBody = new TextArea("This is the body of the popup", 3, 10);
            popupBody.setUIID("PopupBody");
            popupBody.setEditable(false);
            d.setLayout(new BorderLayout());
            d.add(BorderLayout.CENTER, popupBody);
            d.showPopupDialog(showPopup);
        }
    });

See this sample for showing a dialog at the bottom of the screen:

    Dialog dlg = new Dialog("At Bottom");
    dlg.setLayout(new BorderLayout());
    // span label accepts the text and the UIID for the dialog body
    dlg.add(new SpanLabel("Dialog Body text", "DialogBody"));
    int h = Display.getInstance().getDisplayHeight();
    dlg.setDisposeWhenPointerOutOfBounds(true);
    dlg.show(h /8 * 7, 0, 0, 0);

- ## Nested Class Summary

  ### Nested classes/interfaces inherited from class Form

  `Form.TabIterator`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final int`
  `TYPE_ALARM`
  Constant indicating the type of alert to indicate the sound to play or icon if none are explicitly set
  `static final int`
  `TYPE_CONFIRMATION`
  Constant indicating the type of alert to indicate the sound to play or icon if none are explicitly set
  `static final int`
  `TYPE_ERROR`
  Constant indicating the type of alert to indicate the sound to play or icon if none are explicitly set
  `static final int`
  `TYPE_INFO`
  Constant indicating the type of alert to indicate the sound to play or icon if none are explicitly set
  `static final int`
  `TYPE_NONE`
  Constant indicating the type of alert to indicate the sound to play or icon if none are explicitly set
  `static final int`
  `TYPE_WARNING`
  Constant indicating the type of alert to indicate the sound to play or icon if none are explicitly set

  ### Fields inherited from class Form

  `focusScrolling`

  ### Fields inherited from class Component

  `BASELINE, BOTTOM, BRB_CENTER_OFFSET, BRB_CONSTANT_ASCENT, BRB_CONSTANT_DESCENT, BRB_OTHER, CENTER, CROSSHAIR_CURSOR, DEFAULT_CURSOR, DRAG_REGION_IMMEDIATELY_DRAG_X, DRAG_REGION_IMMEDIATELY_DRAG_XY, DRAG_REGION_IMMEDIATELY_DRAG_Y, DRAG_REGION_LIKELY_DRAG_X, DRAG_REGION_LIKELY_DRAG_XY, DRAG_REGION_LIKELY_DRAG_Y, DRAG_REGION_NOT_DRAGGABLE, DRAG_REGION_POSSIBLE_DRAG_X, DRAG_REGION_POSSIBLE_DRAG_XY, DRAG_REGION_POSSIBLE_DRAG_Y, E_RESIZE_CURSOR, HAND_CURSOR, LEFT, MOVE_CURSOR, N_RESIZE_CURSOR, NE_RESIZE_CURSOR, NW_RESIZE_CURSOR, RIGHT, S_RESIZE_CURSOR, SE_RESIZE_CURSOR, SW_RESIZE_CURSOR, TEXT_CURSOR, TOP, W_RESIZE_CURSOR, WAIT_CURSOR`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Dialog()`
  Constructs a Dialog
  `Dialog(Layout lm)`
  Constructs a Dialog with a layout
  `Dialog(String title)`
  Constructs a Dialog with a title
  `Dialog(String title, Layout lm)`
  Constructs a Dialog with a title

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected void`
  `actionCommand(Command cmd)`
  Invoked to allow subclasses of form to handle a command from one point rather than implementing many command instances
  `void`
  `addComponent(int index, Component cmp)`
  Adds Component to the Form's Content Pane
  `void`
  `addComponent(int index, Object constraints, Component cmp)`
  Adds a Component to the Container
  `final void`
  `addComponent(Component cmp)`
  Adds Component to the Form's Content Pane
  `void`
  `addComponent(Object constraints, Component cmp)`
  Adds a Component to the Container
  `boolean`
  `animate()`
  Allows the animation to reduce "repaint" calls when it returns false.
  `protected void`
  `autoAdjust(int w, int h)`
  Auto adjust size of the dialog.
  `void`
  `dispose()`
  Closes the current form and returns to the previous form, releasing the EDT in the process
  `float`
  `getBlurBackgroundRadius()`
  Dialog background can be blurred using a Gaussian blur effect, this sets the radius of the Gaussian blur.
  `Container`
  `getContentPane()`
  This method returns the Content pane instance
  `static float`
  `getDefaultBlurBackgroundRadius()`
  Dialog background can be blurred using a Gaussian blur effect, this sets the radius of the Gaussian blur.
  `static String`
  `getDefaultDialogPosition()`
  Default screen orientation position for the upcoming dialog.
  `static int`
  `getDefaultDialogType()`
  The default type for dialogs
  `Container`
  `getDialogComponent()`
  Returns the container that actually implements the dialog positioning.
  `String`
  `getDialogPosition()`
  Screen orientation position for the upcoming dialog.
  `Dimension`
  `getDialogPreferredSize()`
  Returns the preferred size of the dialog, this allows developers to position a dialog manually in arbitrary positions.
  `Style`
  `getDialogStyle()`
  Simple getter to get the Dialog Style
  `int`
  `getDialogType()`
  The type of the dialog can be one of TYPE_WARNING, TYPE_INFO, TYPE_ERROR, TYPE_CONFIRMATION or TYPE_ALARM
  `String`
  `getDialogUIID()`
  Returns the uiid of the dialog
  `Layout`
  `getLayout()`
  Returns the layout manager of the form's content pane.
  `Boolean`
  `getPopupDirectionBiasPortrait()`
  Indicates if we want to enforce directional bias for the popup dialog.
  `String`
  `getTitle()`
  Returns the Form title text
  `Label`
  `getTitleComponent()`
  Allows modifying the title attributes beyond style (e.g. setting icon/alignment etc.)
  `Style`
  `getTitleStyle()`
  Returns the style of the title
  `void`
  `growOrShrink()`
  Allows a dialog component to grow or shrink to its new preferred size
  `protected final void`
  `initGlobalToolbar()`
  Overriden to disable the toolbar in dialogs
  `protected void`
  `initLaf(UIManager uim)`
  Initialize the default transition for the dialogs overriding the forms transition
  `static boolean`
  `isAutoAdjustDialogSize()`
  Indicates whether Codename One should try to automatically adjust a showing dialog size when a screen size change event occurs
  `boolean`
  `isAutoDispose()`
  Determines whether the execution of a command on this dialog implicitly disposes the dialog.
  `static boolean`
  `isCommandsAsButtons()`
  Places commands as buttons at the bottom of the standard static dialogs rather than as softbuttons.
  `static boolean`
  `isDefaultDisposeWhenPointerOutOfBounds()`
  The default pointer out of bounds dispose behavior, notice that this only applies to dialogs and not popup dialogs where this is always true by default
  `static boolean`
  `isDisableStaticDialogScrolling()`
  Allows a developer to indicate his interest that the dialog should no longer scroll on its own but rather rely on the scrolling properties of internal scrollable containers.
  `boolean`
  `isDisposeWhenPointerOutOfBounds()`
  This flag indicates if the dialog should be disposed if a pointer released event occurred out of the dialog content.
  `void`
  `keyReleased(int keyCode)`
  If this Component is focused, the key released event will call this method
  `protected void`
  `onShow()`
  Allows subclasses to bind functionality that occurs when a specific form or dialog appears on the screen
  `void`
  `placeButtonCommands(Command[] cmds)`
  Places the given commands in the dialog command area, this is very useful for touch devices.
  `void`
  `pointerPressed(int x, int y)`
  If this Component is focused, the pointer pressed event will call this method
  `void`
  `pointerReleased(int x, int y)`
  If this Component is focused, the pointer released event will call this method
  `void`
  `removeAll()`
  Removes all Components from the Content Pane
  `void`
  `removeComponent(Component cmp)`
  Removes a component from the Form's Content Pane
  `static void`
  `setAutoAdjustDialogSize(boolean a)`
  Indicates whether Codename One should try to automatically adjust a showing dialog size when a screen size change event occurs
  `final void`
  `setAutoDispose(boolean autoDispose)`
  Determines whether the execution of a command on this dialog implicitly disposes the dialog.
  `void`
  `setBlurBackgroundRadius(float blurBackgroundRadius)`
  Dialog background can be blurred using a Gaussian blur effect, this sets the radius of the Gaussian blur.
  `static void`
  `setCommandsAsButtons(boolean c)`
  Places commands as buttons at the bottom of the standard static dialogs rather than as softbuttons.
  `static void`
  `setDefaultBlurBackgroundRadius(float aDefaultBlurBackgroundRadius)`
  Dialog background can be blurred using a Gaussian blur effect, this sets the radius of the Gaussian blur.
  `static void`
  `setDefaultDialogPosition(String p)`
  Default screen orientation position for the upcoming dialog.
  `static void`
  `setDefaultDialogType(int d)`
  The default type for dialogs
  `static void`
  `setDefaultDisposeWhenPointerOutOfBounds(boolean aDefaultDisposeWhenPointerOutOfBounds)`
  The default pointer out of bounds dispose behavior, notice that this only applies to dialogs and not popup dialogs where this is always true by default
  `void`
  `setDialogPosition(String dialogPosition)`
  Screen orientation position for the upcoming dialog.
  `void`
  `setDialogStyle(Style style)`
  Simple setter to set the Dialog Style
  `void`
  `setDialogType(int dialogType)`
  The type of the dialog can be one of TYPE_WARNING, TYPE_INFO, TYPE_ERROR, TYPE_CONFIRMATION or TYPE_ALARM
  `void`
  `setDialogUIID(String uiid)`
  Simple setter to set the Dialog uiid
  `static void`
  `setDisableStaticDialogScrolling(boolean d)`
  Allows a developer to indicate his interest that the dialog should no longer scroll on its own but rather rely on the scrolling properties of internal scrollable containers.
  `final void`
  `setDisposeWhenPointerOutOfBounds(boolean disposeWhenPointerOutOfBounds)`
  This flag indicates if the dialog should be disposed if a pointer released event occurred out of the dialog content.
  `final void`
  `setLayout(Layout layout)`
  Sets the layout manager responsible for arranging this container
  `void`
  `setPopupDirectionBiasPortrait(Boolean popupDirectionBiasPortrait)`
  Indicates if we want to enforce directional bias for the popup dialog.
  `void`
  `setPreviousForm(Form previousForm)`
  When the dialog is disposed this form will show.
  `void`
  `setScrollable(boolean scrollable)`
  The equivalent of calling both setScrollableY and setScrollableX
  `void`
  `setTimeout(long time)`
  Indicates the time (in milliseconds) afterwhich the dialog will be disposed implicitly
  `final void`
  `setTitle(String title)`
  Sets the Form title to the given text
  `void`
  `setTitleComponent(Label title)`
  Allows replacing the title with a different title component, thus allowing developers to create more elaborate title objects.
  `void`
  `setTitleComponent(Label title, Transition t)`
  Allows replacing the title with a different title component, thus allowing developers to create more elaborate title objects.
  `void`
  `setUIIDByPopupPosition(boolean b)`
  Allows to use the UIIDs "PopupContentPaneDownwards", "PopupContentPaneUpwards", "PopupContentPaneRight", "PopupContentPaneLeft" (instead of the default UIID "PopupContentPane") to style the PopupDialog more accurately based on the position of the dialog popup compared to the context component.
  `void`
  `show()`
  The default version of show modal shows the dialog occupying the center portion of the screen.
  `Command`
  `show(int top, int bottom, int left, int right)`
  This method shows the form as a modal alert allowing us to produce a behavior of an alert/dialog box.
  `Command`
  `show(int top, int bottom, int left, int right, boolean includeTitle)`
  This method shows the form as a modal alert allowing us to produce a behavior of an alert/dialog box.
  `Command`
  `show(int top, int bottom, int left, int right, boolean includeTitle, boolean modal)`
  This method shows the form as a modal alert allowing us to produce a behavior of an alert/dialog box.
  `static Command`
  `show(String title, Component body, Command... cmds)`
  Shows a modal dialog with the given component as its "body" placed in the center.
  `static Command`
  `show(String title, Component body, Command[] cmds, int type, Image icon)`
  Shows a modal dialog with the given component as its "body" placed in the center.
  `static Command`
  `show(String title, Component body, Command[] cmds, int type, Image icon, long timeout)`
  Shows a modal dialog with the given component as its "body" placed in the center.
  `static Command`
  `show(String title, Component body, Command[] cmds, int type, Image icon, long timeout, Transition transition)`
  Shows a modal dialog with the given component as its "body" placed in the center.
  `static Command`
  `show(String title, Component body, Command defaultCommand, Command[] cmds, int type, Image icon, long timeout, Transition transition)`
  Shows a modal dialog with the given component as its "body" placed in the center.
  `static boolean`
  `show(String title, String text, int type, Image icon, String okText, String cancelText)`
  Shows a modal prompt dialog with the given title and text.
  `static boolean`
  `show(String title, String text, int type, Image icon, String okText, String cancelText, long timeout)`
  Shows a modal prompt dialog with the given title and text.
  `static Command`
  `show(String title, String body, Command... cmds)`
  Shows a modal dialog with the given component as its "body" placed in the center.
  `static Command`
  `show(String title, String text, Command[] cmds, int type, Image icon, long timeout)`
  Shows a modal prompt dialog with the given title and text.
  `static Command`
  `show(String title, String text, Command[] cmds, int type, Image icon, long timeout, Transition transition)`
  Shows a modal prompt dialog with the given title and text.
  `static Command`
  `show(String title, String text, Command defaultCommand, Command[] cmds, int type, Image icon, long timeout)`
  Shows a modal prompt dialog with the given title and text.
  `static Command`
  `show(String title, String text, Command defaultCommand, Command[] cmds, int type, Image icon, long timeout, Transition transition)`
  Shows a modal prompt dialog with the given title and text.
  `static boolean`
  `show(String title, String text, String okText, String cancelText)`
  Shows a modal prompt dialog with the given title and text.
  `Command`
  `showAtPosition(int top, int bottom, int left, int right, boolean modal)`
  This method shows the form as a modal alert allowing us to produce a behavior of an alert/dialog box.
  `void`
  `showBack()`
  Displays the current form on the screen, this version of the method is useful for "back" navigation since it reverses the direction of the transition.
  `Command`
  `showDialog()`
  Shows a modal dialog and returns the command pressed within the modal dialog
  `void`
  `showModeless()`
  Shows a modeless dialog which is useful for some simpler use cases such as progress indication etc...
  `Command`
  `showPacked(String position, boolean modal)`
  Convenience method to show a dialog sized to match its content.
  `Command`
  `showPopupDialog(Component c)`
  A popup dialog is shown with the context of a component and its selection, it is disposed seamlessly if the back button is pressed or if the user touches outside its bounds.
  `Command`
  `showPopupDialog(Rectangle rect)`
  A popup dialog is shown with the context of a component and its selection, it is disposed seamlessly if the back button is pressed or if the user touches outside its bounds.
  `Command`
  `showStetched(String position, boolean modal)`
  Convenience method to show a dialog stretched to one of the sides
  `Command`
  `showStretched(String position, boolean modal)`
  Convenience method to show a dialog stretched to one of the sides
  `boolean`
  `wasDisposedDueToOutOfBoundsTouch()`
  Returns true if a dialog that was disposed did it because of a pointer out of bounds
  `boolean`
  `wasDisposedDueToRotation()`
  Returns true if the dialog was disposed automatically due to device rotation

  ### Methods inherited from class Form

  `addCommand, addCommand, addCommandListener, addComponentAwaitingRelease, addGameKeyListener, addKeyListener, addOrientationListener, addPasteListener, addShowListener, addSizeChangedListener, animateHierarchy, animateHierarchyAndWait, animateHierarchyFade, animateHierarchyFadeAndWait, animateLayout, animateLayoutAndWait, animateLayoutFade, animateLayoutFadeAndWait, animateUnlayout, animateUnlayoutAndWait, clearComponentsAwaitingRelease, createStatusBar, deregisterAnimated, dispatchCommand, dispatchPaste, findCurrentlyEditingComponent, findNextFocusHorizontal, findNextFocusVertical, getAnimationManager, getBackCommand, getClearCommand, getCommand, getCommandCount, getComponentForm, getComponentIndex, getCurrentInputDevice, getDefaultCommand, getDragRegionStatus, getEditOnShow, getFocused, getFormLayeredPane, getFormLayeredPaneIfExists, getGlassPane, getInvisibleAreaUnderVKB, getLayeredPane, getLayeredPane, getLayeredPane, getLayeredPaneIfExists, getMenuBar, getMenuStyle, getNextComponent, getPreviousComponent, getPropertyNames, getPropertyTypeNames, getPropertyTypes, getPropertyValue, getSafeArea, getScrollAnimationSpeed, getSideGap, getSoftButton, getSoftButtonCount, getSourceCommand, getTabIterator, getTextSelection, getTintColor, getTitleArea, getToolbar, getTransitionInAnimator, getTransitionOutAnimator, getUIManager, grabAnimationLock, hasMedia, hideNotify, isAlwaysTensile, isCyclicFocus, isDragRegion, isEditing, isEnableCursors, isFocusScrolling, isFormBottomPaddingEditingMode, isMinimizeOnBack, isScrollable, isScrollableX, isScrollableY, isScrollVisible, isSingleFocusMode, isSmoothScrolling, keyPressed, keyRepeated, longKeyPress, longPointerPress, onRegisterAnimated, onShowCompleted, paint, paintBackground, paintScrollbars, paramString, pointerDragged, pointerDragged, pointerHover, pointerHoverPressed, pointerHoverReleased, refreshTheme, registerAnimated, releaseAnimationLock, removeAllCommands, removeAllShowListeners, removeCommand, removeCommandListener, removeComponentAwaitingRelease, removeGameKeyListener, removeKeyListener, removeOrientationListener, removePasteListener, removeShowListener, removeSizeChangedListener, replace, replaceAndWait, resumeDragAfterScrolling, scrollComponentToVisible, setAllowEnableLayoutOnPaint, setAlwaysTensile, setBackCommand, setBackCommand, setBgImage, setClearCommand, setCurrentInputDevice, setCyclicFocus, setDefaultCommand, setEditOnShow, setEnableCursors, setFocused, setFocusScrolling, setFormBottomPaddingEditingMode, setGlassPane, setMenuBar, setMenuCellRenderer, setMenuTransitions, setMinimizeOnBack, setOverrideInvisibleAreaUnderVKB, setPropertyValue, setRTL, setSafeAreaChanged, setScrollableX, setScrollableY, setScrollAnimationSpeed, setScrollVisible, setSmoothScrolling, setSourceCommand, setTintColor, setTitleStyle, setToolbar, setToolBar, setTransitionInAnimator, setTransitionOutAnimator, setUIManager, setVisible, shouldPaintStatusBar, shouldSendPointerReleaseToOtherForm, showNotify, sizeChanged, stopEditing`

  ### Methods inherited from class Container

  `add, add, add, add, add, add, addAll, applyRTL, calcPreferredSize, cancelRepaints, clearClientProperties, constrainHeightWhenScrollable, constrainWidthWhenScrollable, contains, createAnimateHierarchy, createAnimateHierarchyFade, createAnimateLayout, createAnimateLayoutFade, createAnimateLayoutFadeAndWait, createAnimateMotion, createAnimateUnlayout, createReplaceTransition, dragInitiated, drop, encloseIn, encloseIn, findDropTargetAt, findFirstFocusable, fireClicked, flushReplace, forceRevalidate, getBottomGap, getChildrenAsList, getClosestComponentTo, getComponentAt, getComponentAt, getComponentCount, getGridPosX, getGridPosY, getLayoutHeight, getLayoutWidth, getLeadComponent, getLeadParent, getResponderAt, getSafeAreaRoot, getScrollIncrement, invalidate, isEnabled, isSafeArea, isSafeAreaRoot, isSelectableInteraction, isSurface, iterator, iterator, layoutContainer, morph, morphAndWait, paintComponentBackground, paintGlass, replace, replaceAndWait, replaceAndWait, revalidate, revalidateLater, revalidateWithAnimationSafety, setCellRenderer, setEnabled, setLeadComponent, setSafeArea, setSafeAreaRoot, setScrollIncrement, setShouldCalcPreferredSize, setShouldLayout, updateTabIndices`

  ### Methods inherited from class Component

  `addDragFinishedListener, addDragOverListener, addDropListener, addFocusListener, addLongPressListener, addPointerDraggedListener, addPointerPressedListener, addPointerReleasedListener, addPullToRefresh, addScrollListener, addStateChangeListener, announceForAccessibility, bindProperty, blocksSideSwipe, calcScrollSize, contains, containsOrOwns, createStyleAnimation, deinitialize, deinitializeCustomStyle, dragEnter, dragExit, dragFinished, draggingOver, drawDraggedImage, focusGained, focusLost, getAbsoluteX, getAbsoluteY, getAccessibilityText, getAllStyles, getBaseline, getBaselineResizeBehavior, getBindablePropertyNames, getBindablePropertyTypes, getBorder, getBoundPropertyValue, getBounds, getBounds, getClientProperty, getCloudBoundProperty, getCloudDestinationProperty, getComponentState, getCursor, getDefaultDragTransparency, getDirtyRegion, getDisabledStyle, getDraggedx, getDraggedy, getDragImage, getDragSpeed, getDragTransparency, getEditingDelegate, getHeight, getInlineAllStyles, getInlineDisabledStyles, getInlinePressedStyles, getInlineSelectedStyles, getInlineStylesTheme, getInlineUnselectedStyles, getInnerHeight, getInnerPreferredH, getInnerPreferredW, getInnerWidth, getInnerX, getInnerY, getLabelForComponent, getName, getNativeOverlay, getNextFocusDown, getNextFocusLeft, getNextFocusRight, getNextFocusUp, getOuterHeight, getOuterPreferredH, getOuterPreferredW, getOuterWidth, getOuterX, getOuterY, getOwner, getParent, getPreferredH, getPreferredSize, getPreferredSizeStr, getPreferredTabIndex, getPreferredW, getPressedStyle, getSameHeight, getSameWidth, getScrollable, getScrollDimension, getScrollOpacity, getScrollOpacityChangeSpeed, getScrollX, getScrollY, getSelectCommandText, getSelectedRect, getSelectedStyle, getStyle, getTabIndex, getTensileLength, getTextSelectionSupport, getTooltip, getUIID, getUnselectedStyle, getVisibleBounds, getVisibleBounds, getWidth, getX, getY, growShrink, handlesInput, hasFixedPreferredSize, hasFocus, hideNativeOverlay, initComponent, initCustomStyle, initDisabledStyle, initPressedStyle, initSelectedStyle, initUnselectedStyle, installDefaultPainter, isBlockLead, isCellRenderer, isChildOf, isDragActivated, isDragAndDropOperation, isDraggable, isDropTarget, isEditable, isFlatten, isFocusable, isGrabsPointerEvents, isHidden, isHidden, isHideInLandscape, isHideInPortrait, isIgnorePointerEvents, isInClippingRegion, isInitialized, isOpaque, isOwnedBy, isPinchBlocksDragAndDrop, isRippleEffect, isRTL, isSetCursorSupported, isSnapToGrid, isStickyDrag, isTactileTouch, isTactileTouch, isTensileDragEnabled, isTraversable, isVisible, laidOut, onScrollX, onScrollY, onSetFocusable, paintBackgrounds, paintBorder, paintBorderBackground, paintComponent, paintComponent, paintIntersectingComponentsAbove, paintLock, paintLockRelease, paintRippleOverlay, paintScrollbarX, paintScrollbarY, paintShadows, parsePreferredSize, pinch, pinch, pinchReleased, pointerPressed, pointerReleased, putClientProperty, refreshTheme, refreshTheme, remove, removeDragFinishedListener, removeDragOverListener, removeDropListener, removeFocusListener, removeLongPressListener, removePointerDraggedListener, removePointerPressedListener, removePointerReleasedListener, removeScrollListener, removeStateChangeListener, repaint, repaint, requestFocus, resetFocusable, respondsToPointerEvents, scrollRectToVisible, scrollRectToVisible, setAccessibilityText, setBlockLead, setBoundPropertyValue, setCloudBoundProperty, setCloudDestinationProperty, setComponentState, setCursor, setDefaultDragTransparency, setDirtyRegion, setDisabledStyle, setDraggable, setDragTransparency, setDropTarget, setEditingDelegate, setFlatten, setFocus, setFocusable, setGrabsPointerEvents, setHandlesInput, setHeight, setHidden, setHidden, setHideInLandscape, setHideInPortrait, setIgnorePointerEvents, setInitialized, setInlineAllStyles, setInlineDisabledStyles, setInlinePressedStyles, setInlineSelectedStyles, setInlineStylesTheme, setInlineUnselectedStyles, setIsScrollVisible, setLabelForComponent, setName, setNextFocusDown, setNextFocusLeft, setNextFocusRight, setNextFocusUp, setOpaque, setOwner, setPinchBlocksDragAndDrop, setPreferredH, setPreferredSize, setPreferredSizeStr, setPreferredTabIndex, setPreferredW, setPressedStyle, setRippleEffect, setSameHeight, setSameSize, setSameWidth, setScrollOpacityChangeSpeed, setScrollSize, setScrollX, setScrollY, setSelectCommandText, setSelectedStyle, setSize, setSnapToGrid, setTabIndex, setTactileTouch, setTensileDragEnabled, setTensileLength, setTooltip, setTraversable, setUIID, setUIID, setUIIDFinal, setUnselectedStyle, setWidth, setX, setY, shouldBlockSideSwipe, shouldBlockSideSwipeLeft, shouldBlockSideSwipeRight, shouldRenderComponentSelection, showNativeOverlay, startEditingAsync, stripMarginAndPadding, styleChanged, toImage, toString, unbindProperty, updateNativeOverlay, visibleBoundsContains`

  ### Methods inherited from class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface Iterable

  `forEach, spliterator`

- ## Field Details

  - ### TYPE_NONE

    public static final int TYPE_NONE
    Constant indicating the type of alert to indicate the sound to play or icon if none are explicitly set
    See Also:
      - Constant Field Values

  - ### TYPE_ALARM

    public static final int TYPE_ALARM
    Constant indicating the type of alert to indicate the sound to play or icon if none are explicitly set
    See Also:
      - Constant Field Values

  - ### TYPE_CONFIRMATION

    public static final int TYPE_CONFIRMATION
    Constant indicating the type of alert to indicate the sound to play or icon if none are explicitly set
    See Also:
      - Constant Field Values

  - ### TYPE_ERROR

    public static final int TYPE_ERROR
    Constant indicating the type of alert to indicate the sound to play or icon if none are explicitly set
    See Also:
      - Constant Field Values

  - ### TYPE_INFO

    public static final int TYPE_INFO
    Constant indicating the type of alert to indicate the sound to play or icon if none are explicitly set
    See Also:
      - Constant Field Values

  - ### TYPE_WARNING

    public static final int TYPE_WARNING
    Constant indicating the type of alert to indicate the sound to play or icon if none are explicitly set
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### Dialog

    public Dialog(String title)

    Constructs a Dialog with a title

    ###### Parameters

    - `title`: the title of the dialog

  - ### Dialog

    public Dialog(String title, Layout lm)

    Constructs a Dialog with a title

    ###### Parameters

    - `title`: the title of the dialog

    - `lm`: the layout for the dialog

  - ### Dialog

    public Dialog()
    Constructs a Dialog

  - ### Dialog

    public Dialog(Layout lm)

    Constructs a Dialog with a layout

    ###### Parameters

    - `lm`: the layout manager

- ## Method Details

  - ### isDefaultDisposeWhenPointerOutOfBounds

    public static boolean isDefaultDisposeWhenPointerOutOfBounds()

    The default pointer out of bounds dispose behavior, notice that this only applies to dialogs and not popup dialogs where this is always true by default

    ###### Returns

    the defaultDisposeWhenPointerOutOfBounds

  - ### setDefaultDisposeWhenPointerOutOfBounds

    public static void setDefaultDisposeWhenPointerOutOfBounds(boolean aDefaultDisposeWhenPointerOutOfBounds)

    The default pointer out of bounds dispose behavior, notice that this only applies to dialogs and not popup dialogs where this is always true by default

    ###### Parameters

    - `aDefaultDisposeWhenPointerOutOfBounds`: the defaultDisposeWhenPointerOutOfBounds to set

  - ### show

    public static boolean show(String title, String text, int type, Image icon, String okText, String cancelText)

    Shows a modal prompt dialog with the given title and text.

    ###### Parameters

    - `title`: The title for the dialog optionally null;

    - `text`: the text displayed in the dialog

    - `type`: @param type the type of the alert one of TYPE_WARNING, TYPE_INFO, TYPE_ERROR, TYPE_CONFIRMATION or TYPE_ALARM

    - `icon`: the icon for the dialog, can be null

    - `okText`: the text to appear in the command dismissing the dialog

    - `cancelText`: @param cancelText optionally null for a text to appear in the cancel command for canceling the dialog

    ###### Returns

    true if the ok command was pressed or if cancelText is null. False otherwise.

  - ### show

    public static boolean show(String title, String text, int type, Image icon, String okText, String cancelText, long timeout)

    Shows a modal prompt dialog with the given title and text.

    ###### Parameters

    - `title`: The title for the dialog optionally null;

    - `text`: the text displayed in the dialog

    - `type`: @param type the type of the alert one of TYPE_WARNING, TYPE_INFO, TYPE_ERROR, TYPE_CONFIRMATION or TYPE_ALARM

    - `icon`: the icon for the dialog, can be null

    - `okText`: the text to appear in the command dismissing the dialog

    - `cancelText`: @param cancelText optionally null for a text to appear in the cancel command for canceling the dialog

    - `timeout`: a timeout after which null would be returned if timeout is 0 inifinite time is used

    ###### Returns

    true if the ok command was pressed or if cancelText is null. False otherwise.

  - ### show

    public static Command show(String title, String text, Command[] cmds, int type, Image icon, long timeout)

    Shows a modal prompt dialog with the given title and text.

    ###### Parameters

    - `title`: The title for the dialog optionally null;

    - `text`: the text displayed in the dialog

    - `cmds`: @param cmds commands that are added to the form any click on any command will dispose the form

    - `type`: @param type the type of the alert one of TYPE_WARNING, TYPE_INFO, TYPE_ERROR, TYPE_CONFIRMATION or TYPE_ALARM

    - `icon`: the icon for the dialog, can be null

    - `timeout`: a timeout after which null would be returned if timeout is 0 inifinite time is used

    ###### Returns

    the command pressed by the user

  - ### show

    public static Command show(String title, String text, Command defaultCommand, Command[] cmds, int type, Image icon, long timeout)

    Shows a modal prompt dialog with the given title and text.

    ###### Parameters

    - `title`: The title for the dialog optionally null;

    - `text`: the text displayed in the dialog

    - `defaultCommand`: command to be assigned as the default command or null

    - `cmds`: @param cmds commands that are added to the form any click on any command will dispose the form

    - `type`: @param type the type of the alert one of TYPE_WARNING, TYPE_INFO, TYPE_ERROR, TYPE_CONFIRMATION or TYPE_ALARM

    - `icon`: the icon for the dialog, can be null

    - `timeout`: a timeout after which null would be returned if timeout is 0 inifinite time is used

    ###### Returns

    the command pressed by the user

  - ### show

    public static Command show(String title, String text, Command[] cmds, int type, Image icon, long timeout, Transition transition)

    Shows a modal prompt dialog with the given title and text.

    ###### Parameters

    - `title`: The title for the dialog optionally null;

    - `text`: the text displayed in the dialog

    - `cmds`: @param cmds commands that are added to the form any click on any command will dispose the form

    - `type`: @param type the type of the alert one of TYPE_WARNING, TYPE_INFO, TYPE_ERROR, TYPE_CONFIRMATION or TYPE_ALARM

    - `icon`: the icon for the dialog, can be null

    - `timeout`: a timeout after which null would be returned if timeout is 0 inifinite time is used

    - `transition`: the transition installed when the dialog enters/leaves

    ###### Returns

    the command pressed by the user

  - ### show

    public static Command show(String title, String text, Command defaultCommand, Command[] cmds, int type, Image icon, long timeout, Transition transition)

    Shows a modal prompt dialog with the given title and text.

    ###### Parameters

    - `title`: The title for the dialog optionally null;

    - `text`: the text displayed in the dialog

    - `defaultCommand`: command to be assigned as the default command or null

    - `cmds`: @param cmds commands that are added to the form any click on any command will dispose the form

    - `type`: @param type the type of the alert one of TYPE_WARNING, TYPE_INFO, TYPE_ERROR, TYPE_CONFIRMATION or TYPE_ALARM

    - `icon`: the icon for the dialog, can be null

    - `timeout`: a timeout after which null would be returned if timeout is 0 inifinite time is used

    - `transition`: the transition installed when the dialog enters/leaves

    ###### Returns

    the command pressed by the user

  - ### show

    public static boolean show(String title, String text, String okText, String cancelText)

    Shows a modal prompt dialog with the given title and text.

    ###### Parameters

    - `title`: The title for the dialog optionally null;

    - `text`: the text displayed in the dialog

    - `okText`: the text to appear in the command dismissing the dialog

    - `cancelText`: @param cancelText optionally null for a text to appear in the cancel command for canceling the dialog

    ###### Returns

    true if the ok command was pressed or if cancelText is null. False otherwise.

  - ### show

    public static Command show(String title, Component body, Command... cmds)

    Shows a modal dialog with the given component as its "body" placed in the center.

    ###### Parameters

    - `title`: title for the dialog

    - `body`: component placed in the center of the dialog

    - `cmds`: @param cmds commands that are added to the form any click on any command will dispose the form

    ###### Returns

    the command pressed by the user

  - ### show

    public static Command show(String title, String body, Command... cmds)

    Shows a modal dialog with the given component as its "body" placed in the center.

    ###### Parameters

    - `title`: title for the dialog

    - `body`: text placed in the center of the dialog

    - `cmds`: @param cmds commands that are added to the form any click on any command will dispose the form

    ###### Returns

    the command pressed by the user

  - ### show

    public static Command show(String title, Component body, Command[] cmds, int type, Image icon)

    Shows a modal dialog with the given component as its "body" placed in the center.

    ###### Parameters

    - `title`: title for the dialog

    - `body`: component placed in the center of the dialog

    - `cmds`: @param cmds commands that are added to the form any click on any command will dispose the form

    - `type`: @param type the type of the alert one of TYPE_WARNING, TYPE_INFO, TYPE_ERROR, TYPE_CONFIRMATION or TYPE_ALARM

    - `icon`: the icon for the dialog, can be null

    ###### Returns

    the command pressed by the user

  - ### show

    public static Command show(String title, Component body, Command[] cmds, int type, Image icon, long timeout)

    Shows a modal dialog with the given component as its "body" placed in the center.

    ###### Parameters

    - `title`: title for the dialog

    - `body`: component placed in the center of the dialog

    - `cmds`: @param cmds commands that are added to the form any click on any command will dispose the form

    - `type`: @param type the type of the alert one of TYPE_WARNING, TYPE_INFO, TYPE_ERROR, TYPE_CONFIRMATION or TYPE_ALARM

    - `icon`: the icon for the dialog, can be null

    - `timeout`: a timeout after which null would be returned if timeout is 0 inifinite time is used

    ###### Returns

    the command pressed by the user

  - ### show

    public static Command show(String title, Component body, Command[] cmds, int type, Image icon, long timeout, Transition transition)

    Shows a modal dialog with the given component as its "body" placed in the center.

    ###### Parameters

    - `title`: title for the dialog

    - `body`: component placed in the center of the dialog

    - `cmds`: @param cmds commands that are added to the form any click on any command will dispose the form

    - `type`: @param type the type of the alert one of TYPE_WARNING, TYPE_INFO, TYPE_ERROR, TYPE_CONFIRMATION or TYPE_ALARM

    - `icon`: the icon for the dialog, can be null

    - `timeout`: a timeout after which null would be returned if timeout is 0 infinite time is used

    - `transition`: the transition installed when the dialog enters/leaves

    ###### Returns

    the command pressed by the user

  - ### show

    public static Command show(String title, Component body, Command defaultCommand, Command[] cmds, int type, Image icon, long timeout, Transition transition)

    Shows a modal dialog with the given component as its "body" placed in the center.

    ###### Parameters

    - `title`: title for the dialog

    - `body`: component placed in the center of the dialog

    - `defaultCommand`: command to be assigned as the default command or null

    - `cmds`: @param cmds commands that are added to the form any click on any command will dispose the form

    - `type`: @param type the type of the alert one of TYPE_WARNING, TYPE_INFO, TYPE_ERROR, TYPE_CONFIRMATION or TYPE_ALARM

    - `icon`: the icon for the dialog, can be null

    - `timeout`: a timeout after which null would be returned if timeout is 0 inifinite time is used

    - `transition`: the transition installed when the dialog enters/leaves

    ###### Returns

    the command pressed by the user

  - ### getDefaultDialogPosition

    public static String getDefaultDialogPosition()

    Default screen orientation position for the upcoming dialog. By default the dialog will be shown at hardcoded coordinates, this method allows us to pack the dialog appropriately in one of the border layout based locations see BorderLayout for futher details.

    ###### Returns

    position for dialogs on the sceen using BorderLayout orientation tags

  - ### setDefaultDialogPosition

    public static void setDefaultDialogPosition(String p)

    Default screen orientation position for the upcoming dialog. By default the dialog will be shown at hardcoded coordinates, this method allows us to pack the dialog appropriately in one of the border layout based locations see BorderLayout for futher details.

    ###### Parameters

    - `p`: for dialogs on the sceen using BorderLayout orientation tags

  - ### getDefaultDialogType

    public static int getDefaultDialogType()

    The default type for dialogs

    ###### Returns

    the default type for the dialog

  - ### setDefaultDialogType

    public static void setDefaultDialogType(int d)

    The default type for dialogs

    ###### Parameters

    - `d`: the default type for the dialog

  - ### isAutoAdjustDialogSize

    public static boolean isAutoAdjustDialogSize()

    Indicates whether Codename One should try to automatically adjust a showing dialog size when a screen size change event occurs

    ###### Returns

    true to indicate that Codename One should make a "best effort" to resize the dialog

  - ### setAutoAdjustDialogSize

    public static void setAutoAdjustDialogSize(boolean a)

    Indicates whether Codename One should try to automatically adjust a showing dialog size when a screen size change event occurs

    ###### Parameters

    - `a`: true to indicate that Codename One should make a "best effort" to resize the dialog

  - ### isDisableStaticDialogScrolling

    public static boolean isDisableStaticDialogScrolling()

    Allows a developer to indicate his interest that the dialog should no longer scroll on its own but rather rely on the scrolling properties of internal scrollable containers. This flag only affects the static show methods within this class.

    ###### Returns

    true if scrolling should be activated, false otherwise

  - ### setDisableStaticDialogScrolling

    public static void setDisableStaticDialogScrolling(boolean d)

    Allows a developer to indicate his interest that the dialog should no longer scroll on its own but rather rely on the scrolling properties of internal scrollable containers. This flag only affects the static show methods within this class.

    ###### Parameters

    - `d`: indicates whether scrolling should be active or not

  - ### isCommandsAsButtons

    public static boolean isCommandsAsButtons()

    Places commands as buttons at the bottom of the standard static dialogs rather than as softbuttons. This is especially appropriate for devices such as touch devices and devices without the common softbuttons (e.g. blackberries). The default value is false

    ###### Returns

    true if commands are placed as buttons and not as softbutton keys

  - ### setCommandsAsButtons

    public static void setCommandsAsButtons(boolean c)

    Places commands as buttons at the bottom of the standard static dialogs rather than as softbuttons. This is especially appropriate for devices such as touch devices and devices without the common softbuttons (e.g. blackberries). The default value is false

    ###### Parameters

    - `c`: true to place commands as buttons and not as softbutton keys

  - ### getDefaultBlurBackgroundRadius

    public static float getDefaultBlurBackgroundRadius()

    Dialog background can be blurred using a Gaussian blur effect, this sets the radius of the Gaussian blur. -1 is a special case value that indicates that no blurring should take effect and the default tint mode only should be used

    ###### Returns

    the defaultBlurBackgroundRadius

  - ### setDefaultBlurBackgroundRadius

    public static void setDefaultBlurBackgroundRadius(float aDefaultBlurBackgroundRadius)

    Dialog background can be blurred using a Gaussian blur effect, this sets the radius of the Gaussian blur. -1 is a special case value that indicates that no blurring should take effect and the default tint mode only should be used. Notice that this value can be set using the theme constant: `dialogBlurRadiusInt`

    ###### Parameters

    - `aDefaultBlurBackgroundRadius`: the defaultBlurBackgroundRadius to set

  - ### setPreviousForm

    public void setPreviousForm(Form previousForm)

    When the dialog is disposed this form will show. Notice that this can only be set after show was invoked!

    ###### Parameters

    - `previousForm`: the previous form

  - ### initGlobalToolbar

    protected final void initGlobalToolbar()

    Overriden to disable the toolbar in dialogs

    Allows subclasses to disable the global toolbar for a specific form by overriding this method

    Overrides:
      `initGlobalToolbar` in class `Form`

  - ### getContentPane

    public Container getContentPane()
    Description copied from class: `Form`

    This method returns the Content pane instance

    ###### Returns

    a content pane instance

    Overrides:
      `getContentPane` in class `Form`

  - ### getLayout

    public Layout getLayout()

    Returns the layout manager of the form's content pane.

    ###### See also

    - #getActualLayout() For the actual layout of the form.
    Overrides:
      `getLayout` in class `Form`

  - ### setLayout

    public final void setLayout(Layout layout)

    Sets the layout manager responsible for arranging this container

    ###### Parameters

    - `layout`: the specified layout manager
    Overrides:
      `setLayout` in class `Form`

  - ### getTitle

    public String getTitle()

    Returns the Form title text

    ###### Returns

    returns the form title

    Overrides:
      `getTitle` in class `Form`

  - ### setTitle

    public final void setTitle(String title)

    Sets the Form title to the given text

    ###### Parameters

    - `title`: the form title
    Overrides:
      `setTitle` in class `Form`

  - ### addComponent

    public final void addComponent(Component cmp)

    Adds Component to the Form's Content Pane

    ###### Parameters

    - `cmp`: the added param
    Overrides:
      `addComponent` in class `Form`

  - ### addComponent

    public void addComponent(Object constraints, Component cmp)

    Adds a Component to the Container

    ###### Parameters

    - `constraints`: @param constraints this method is useful when the Layout requires a constraint such as the BorderLayout. In this case you need to specify an additional data when you add a Component, such as "CENTER", "NORTH"...

    - `cmp`: component to add

    Overrides:
      `addComponent` in class `Form`

  - ### addComponent

    public void addComponent(int index, Object constraints, Component cmp)

    Adds a Component to the Container

    ###### Parameters

    - `index`: location to insert the Component

    - `constraints`: @param constraints this method is useful when the Layout requires a constraint such as the BorderLayout. In this case you need to specify an additional data when you add a Component, such as "CENTER", "NORTH"...

    - `cmp`: component to add

    Overrides:
      `addComponent` in class `Form`

  - ### addComponent

    public void addComponent(int index, Component cmp)

    Adds Component to the Form's Content Pane

    ###### Parameters

    - `cmp`: the added param
    Overrides:
      `addComponent` in class `Form`

  - ### removeAll

    public void removeAll()
    Removes all Components from the Content Pane
    Overrides:
      `removeAll` in class `Form`

  - ### removeComponent

    public void removeComponent(Component cmp)

    Removes a component from the Form's Content Pane

    ###### Parameters

    - `cmp`: the component to be removed
    Overrides:
      `removeComponent` in class `Form`

  - ### getTitleComponent

    public Label getTitleComponent()

    Allows modifying the title attributes beyond style (e.g. setting icon/alignment etc.)

    ###### Returns

    the component representing the title for the form

    Overrides:
      `getTitleComponent` in class `Form`

  - ### setTitleComponent

    public void setTitleComponent(Label title)

    Allows replacing the title with a different title component, thus allowing developers to create more elaborate title objects.

    ###### Parameters

    - `title`: new title component
    Overrides:
      `setTitleComponent` in class `Form`

  - ### getTitleStyle

    public Style getTitleStyle()

    Returns the style of the title

    ###### Returns

    the style of the title

    Overrides:
      `getTitleStyle` in class `Form`

  - ### getDialogComponent

    public Container getDialogComponent()

    Returns the container that actually implements the dialog positioning. This container is normally not accessible via the Codename One API.

    ###### Returns

    internal dialog container useful for various calculations.

  - ### setTitleComponent

    public void setTitleComponent(Label title, Transition t)

    Allows replacing the title with a different title component, thus allowing developers to create more elaborate title objects. This version of the method allows special effects for title replacement such as transitions for title entering

    ###### Parameters

    - `title`: new title component

    - `t`: transition for title replacement

    Overrides:
      `setTitleComponent` in class `Form`

  - ### getDialogUIID

    public String getDialogUIID()

    Returns the uiid of the dialog

    ###### Returns

    the uiid of the dialog

  - ### setDialogUIID

    public void setDialogUIID(String uiid)

    Simple setter to set the Dialog uiid

    ###### Parameters

    - `uiid`: the id for the dialog

  - ### getDialogStyle

    public Style getDialogStyle()

    Simple getter to get the Dialog Style

    ###### Returns

    the style of the dialog

  - ### setDialogStyle

    public void setDialogStyle(Style style)

    Simple setter to set the Dialog Style

    ###### Parameters

    - `style`

  - ### initLaf

    protected void initLaf(UIManager uim)

    Initialize the default transition for the dialogs overriding the forms transition

    ###### Parameters

    - `uim`: the UIManager instance
    Overrides:
      `initLaf` in class `Form`

  - ### show

    public Command show(int top, int bottom, int left, int right, boolean includeTitle)

    This method shows the form as a modal alert allowing us to produce a behavior of an alert/dialog box. This method will block the calling thread even if the calling thread is the EDT. Notice that this method will not release the block until dispose is called even if show() from another form is called!

    Modal dialogs Allow the forms "content" to "hang in mid air" this is especially useful for dialogs where you would want the underlying form to "peek" from behind the form.

    ###### Parameters

    - `top`: space in pixels between the top of the screen and the form

    - `bottom`: space in pixels between the bottom of the screen and the form

    - `left`: space in pixels between the left of the screen and the form

    - `right`: space in pixels between the right of the screen and the form

    - `includeTitle`: @param includeTitle whether the title should hang in the top of the screen or be glued onto the content pane

    ###### Returns

    the last command pressed by the user if such a command exists

    ###### Deprecated

  - ### show

    public Command show(int top, int bottom, int left, int right)

    This method shows the form as a modal alert allowing us to produce a behavior of an alert/dialog box. This method will block the calling thread even if the calling thread is the EDT. Notice that this method will not release the block until dispose is called even if show() from another form is called!

    Modal dialogs Allow the forms "content" to "hang in mid air" this is especially useful for dialogs where you would want the underlying form to "peek" from behind the form.

    See this sample for showing a dialog at the bottom of the screen:

        Dialog dlg = new Dialog("At Bottom");
        dlg.setLayout(new BorderLayout());
        // span label accepts the text and the UIID for the dialog body
        dlg.add(new SpanLabel("Dialog Body text", "DialogBody"));
        int h = Display.getInstance().getDisplayHeight();
        dlg.setDisposeWhenPointerOutOfBounds(true);
        dlg.show(h /8 * 7, 0, 0, 0);

    ###### Parameters

    - `top`: space in pixels between the top of the screen and the form

    - `bottom`: space in pixels between the bottom of the screen and the form

    - `left`: space in pixels between the left of the screen and the form

    - `right`: space in pixels between the right of the screen and the form

    ###### Returns

    the last command pressed by the user if such a command exists

  - ### show

    public Command show(int top, int bottom, int left, int right, boolean includeTitle, boolean modal)

    This method shows the form as a modal alert allowing us to produce a behavior of an alert/dialog box. This method will block the calling thread even if the calling thread is the EDT. Notice that this method will not release the block until dispose is called even if show() from another form is called!

    Modal dialogs Allow the forms "content" to "hang in mid air" this is especially useful for dialogs where you would want the underlying form to "peek" from behind the form.

    ###### Parameters

    - `top`: space in pixels between the top of the screen and the form

    - `bottom`: space in pixels between the bottom of the screen and the form

    - `left`: space in pixels between the left of the screen and the form

    - `right`: space in pixels between the right of the screen and the form

    - `includeTitle`: @param includeTitle whether the title should hang in the top of the screen or be glued onto the content pane

    - `modal`: @param modal indicates the dialog should be modal set to false for modeless dialog which is useful for some use cases

    ###### Returns

    the last command pressed by the user if such a command exists

    ###### Deprecated

    use showAtPosition, the includeTitle flag is no longer supported

  - ### showAtPosition

    public Command showAtPosition(int top, int bottom, int left, int right, boolean modal)

    This method shows the form as a modal alert allowing us to produce a behavior of an alert/dialog box. This method will block the calling thread even if the calling thread is the EDT. Notice that this method will not release the block until dispose is called even if show() from another form is called!

    Modal dialogs Allow the forms "content" to "hang in mid air" this is especially useful for dialogs where you would want the underlying form to "peek" from behind the form.

    ###### Parameters

    - `top`: space in pixels between the top of the screen and the form

    - `bottom`: space in pixels between the bottom of the screen and the form

    - `left`: space in pixels between the left of the screen and the form

    - `right`: space in pixels between the right of the screen and the form

    - `modal`: @param modal indicates the dialog should be modal set to false for modeless dialog which is useful for some use cases

    ###### Returns

    the last command pressed by the user if such a command exists

  - ### setTimeout

    public void setTimeout(long time)

    Indicates the time (in milliseconds) afterwhich the dialog will be disposed implicitly

    ###### Parameters

    - `time`: a milliseconds time used to dispose the dialog

  - ### autoAdjust

    protected void autoAdjust(int w, int h)

    Auto adjust size of the dialog. This method is triggered from a sizeChanged event.

    ###### Parameters

    - `w`: width of the screen

    - `h`: height of the screen

  - ### placeButtonCommands

    public void placeButtonCommands(Command[] cmds)

    Places the given commands in the dialog command area, this is very useful for touch devices.

    ###### Parameters

    - `cmds`: the commands to place

    ###### Deprecated

    this method shouldn't be invoked externally, it should have been private

  - ### keyReleased

    public void keyReleased(int keyCode)

    If this Component is focused, the key released event will call this method

    ###### Parameters

    - `keyCode`: the key code value to indicate a physical key.
    Overrides:
      `keyReleased` in class `Form`

  - ### onShow

    protected void onShow()
    Allows subclasses to bind functionality that occurs when a specific form or dialog appears on the screen
    Overrides:
      `onShow` in class `Form`

  - ### showBack

    public void showBack()
    Displays the current form on the screen, this version of the method is useful for "back" navigation since it reverses the direction of the transition.
    Overrides:
      `showBack` in class `Form`

  - ### setScrollable

    public void setScrollable(boolean scrollable)

    The equivalent of calling both setScrollableY and setScrollableX

    ###### Parameters

    - `scrollable`: @param scrollable whether the component should/could scroll on the X and Y axis

    ###### Deprecated

    use setScrollableX and setScrollableY instead. This method is deprecated since it breeds confusion and is often misunderstood.

    Overrides:
      `setScrollable` in class `Form`

  - ### show

    public void show()
    The default version of show modal shows the dialog occupying the center portion of the screen.
    Overrides:
      `show` in class `Form`

  - ### showModeless

    public void showModeless()
    Shows a modeless dialog which is useful for some simpler use cases such as progress indication etc...

  - ### showPopupDialog

    public Command showPopupDialog(Component c)

    A popup dialog is shown with the context of a component and its selection, it is disposed seamlessly if the back button is pressed or if the user touches outside its bounds. It can optionally provide an arrow in the theme to point at the context component. The popup dialog has the PopupDialog style by default.

    ###### Parameters

    - `c`: the context component which is used to position the dialog and can also be pointed at

    ###### Returns

    the command that might have been triggered by the user within the dialog if commands are placed in the dialog

  - ### showPopupDialog

    public Command showPopupDialog(Rectangle rect)

    A popup dialog is shown with the context of a component and its selection, it is disposed seamlessly if the back button is pressed or if the user touches outside its bounds. It can optionally provide an arrow in the theme to point at the context component. The popup dialog has the PopupDialog style by default.

    ###### Parameters

    - `rect`: the screen rectangle to which the popup should point

    ###### Returns

    the command that might have been triggered by the user within the dialog if commands are placed in the dialog

  - ### showPacked

    public Command showPacked(String position, boolean modal)

    Convenience method to show a dialog sized to match its content.

    ###### Parameters

    - `position`: one of the values from the BorderLayout class e.g. BorderLayout.CENTER, BorderLayout.NORTH etc.

    - `modal`: whether the dialog should be modal or modaless

    ###### Returns

    the command selected if the dialog is modal and disposed via a command

  - ### showStretched

    public Command showStretched(String position, boolean modal)

    Convenience method to show a dialog stretched to one of the sides

    ###### Parameters

    - `position`: one of the values from the BorderLayout class except for center e.g. BorderLayout.NORTH, BorderLayout.EAST etc.

    - `modal`: whether the dialog should be modal or modaless

    ###### Returns

    the command selected if the dialog is modal and disposed via a command

  - ### showStetched

    public Command showStetched(String position, boolean modal)

    Convenience method to show a dialog stretched to one of the sides

    ###### Parameters

    - `position`: one of the values from the BorderLayout class except for center e.g. BorderLayout.NORTH, BorderLayout.EAST etc.

    - `modal`: whether the dialog should be modal or modaless

    ###### Returns

    the command selected if the dialog is modal and disposed via a command

    ###### Deprecated

    due to typo use showStretched instead

  - ### getDialogPreferredSize

    public Dimension getDialogPreferredSize()

    Returns the preferred size of the dialog, this allows developers to position a dialog manually in arbitrary positions.

    ###### Returns

    the preferred size of this dialog

  - ### dispose

    public void dispose()
    Closes the current form and returns to the previous form, releasing the EDT in the process

  - ### showDialog

    public Command showDialog()

    Shows a modal dialog and returns the command pressed within the modal dialog

    ###### Returns

    last command pressed in the modal dialog

  - ### actionCommand

    protected void actionCommand(Command cmd)

    Invoked to allow subclasses of form to handle a command from one point rather than implementing many command instances

    ###### Parameters

    - `cmd`: the action command
    Overrides:
      `actionCommand` in class `Form`

  - ### animate

    public boolean animate()

    Allows the animation to reduce "repaint" calls when it returns false. It is called once for every frame. Frames are defined by the `com.codename1.ui.Display` class.

    ###### Returns

    true if a repaint is desired or false if no repaint is necessary

    Specified by:
      `animate` in interface `Animation`
    Overrides:
      `animate` in class `Form`

  - ### isAutoDispose

    public boolean isAutoDispose()

    Determines whether the execution of a command on this dialog implicitly disposes the dialog. This defaults to true which is a sensible default for simple dialogs.

    ###### Returns

    true if this dialog disposes on any command

  - ### setAutoDispose

    public final void setAutoDispose(boolean autoDispose)

    Determines whether the execution of a command on this dialog implicitly disposes the dialog. This defaults to true which is a sensible default for simple dialogs.

    ###### Parameters

    - `autoDispose`: true if this dialog disposes on any command

  - ### getDialogType

    public int getDialogType()

    The type of the dialog can be one of TYPE_WARNING, TYPE_INFO, TYPE_ERROR, TYPE_CONFIRMATION or TYPE_ALARM

    ###### Returns

    Returns:
      can be one of TYPE_WARNING, TYPE_INFO, TYPE_ERROR, TYPE_CONFIRMATION or TYPE_ALARM

  - ### setDialogType

    public void setDialogType(int dialogType)

    The type of the dialog can be one of TYPE_WARNING, TYPE_INFO, TYPE_ERROR, TYPE_CONFIRMATION or TYPE_ALARM

    ###### Parameters

    - `dialogType`: @param dialogType can be one of TYPE_WARNING, TYPE_INFO, TYPE_ERROR, TYPE_CONFIRMATION or TYPE_ALARM

  - ### isDisposeWhenPointerOutOfBounds

    public boolean isDisposeWhenPointerOutOfBounds()

    This flag indicates if the dialog should be disposed if a pointer released event occurred out of the dialog content.

    ###### Returns

    true if the dialog should dispose

  - ### setDisposeWhenPointerOutOfBounds

    public final void setDisposeWhenPointerOutOfBounds(boolean disposeWhenPointerOutOfBounds)

    This flag indicates if the dialog should be disposed if a pointer released event occurred out of the dialog content.

    ###### Parameters

    - `disposeWhenPointerOutOfBounds`

  - ### pointerReleased

    public void pointerReleased(int x, int y)

    If this Component is focused, the pointer released event will call this method

    ###### Parameters

    - `x`: the pointer x coordinate

    - `y`: the pointer y coordinate

    Overrides:
      `pointerReleased` in class `Form`

  - ### pointerPressed

    public void pointerPressed(int x, int y)

    If this Component is focused, the pointer pressed event will call this method

    ###### Parameters

    - `x`: the pointer x coordinate

    - `y`: the pointer y coordinate

    Overrides:
      `pointerPressed` in class `Form`

  - ### wasDisposedDueToOutOfBoundsTouch

    public boolean wasDisposedDueToOutOfBoundsTouch()

    Returns true if a dialog that was disposed did it because of a pointer out of bounds

    ###### Returns

    true when a dialog was disposed due to pointer out of bounds.

  - ### getDialogPosition

    public String getDialogPosition()

    Screen orientation position for the upcoming dialog. By default the dialog will be shown at hardcoded coordinates, this method allows us to pack the dialog appropriately in one of the border layout based locations see BorderLayout for futher details.

    ###### Returns

    the dialogPosition

  - ### setDialogPosition

    public void setDialogPosition(String dialogPosition)

    Screen orientation position for the upcoming dialog. By default the dialog will be shown at hardcoded coordinates, this method allows us to pack the dialog appropriately in one of the border layout based locations see BorderLayout for futher details.

    ###### Parameters

    - `dialogPosition`: the dialogPosition to set

  - ### growOrShrink

    public void growOrShrink()
    Allows a dialog component to grow or shrink to its new preferred size

  - ### getPopupDirectionBiasPortrait

    public Boolean getPopupDirectionBiasPortrait()

    Indicates if we want to enforce directional bias for the popup dialog. If null this field is ignored but if its set to a value it biases the system towards a fixed direction for the popup dialog.

    ###### Returns

    the popupDirectionBiasPortrait

  - ### setPopupDirectionBiasPortrait

    public void setPopupDirectionBiasPortrait(Boolean popupDirectionBiasPortrait)

    Indicates if we want to enforce directional bias for the popup dialog. If null this field is ignored but if its set to a value it biases the system towards a fixed direction for the popup dialog.

    ###### Parameters

    - `popupDirectionBiasPortrait`: the popupDirectionBiasPortrait to set

  - ### wasDisposedDueToRotation

    public boolean wasDisposedDueToRotation()

    Returns true if the dialog was disposed automatically due to device rotation

    ###### Returns

    the disposedDueToRotation value

  - ### getBlurBackgroundRadius

    public float getBlurBackgroundRadius()

    Dialog background can be blurred using a Gaussian blur effect, this sets the radius of the Gaussian blur. -1 is a special case value that indicates that no blurring should take effect and the default tint mode only should be used

    ###### Returns

    the blurBackgroundRadius

  - ### setBlurBackgroundRadius

    public void setBlurBackgroundRadius(float blurBackgroundRadius)

    Dialog background can be blurred using a Gaussian blur effect, this sets the radius of the Gaussian blur. -1 is a special case value that indicates that no blurring should take effect and the default tint mode only should be used. Notice that this value can be set using the theme constant: `dialogBlurRadiusInt`

    ###### Parameters

    - `blurBackgroundRadius`: the blurBackgroundRadius to set

  - ### setUIIDByPopupPosition

    public void setUIIDByPopupPosition(boolean b)

    Allows to use the UIIDs "PopupContentPaneDownwards", "PopupContentPaneUpwards", "PopupContentPaneRight", "PopupContentPaneLeft" (instead of the default UIID "PopupContentPane") to style the PopupDialog more accurately based on the position of the dialog popup compared to the context component.

    ###### Parameters

    - `b`: to enable